#include <iostream>
#include <QNetworkRequest>
#include <QUrl>
#include <QNetworkAccessManager>
#include <QCoreApplication>
#include <thread>
#include <QThread>
#include <QObject>
#include <QNetworkReply>
#include <QJsonDocument>

class PostClass: public QObject {
    Q_OBJECT

public:
    PostClass() {
        manager = new QNetworkAccessManager(this);
        // manager->setAutoDeleteReplies(true);
        connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(onfinish(QNetworkReply*)));
        req1 = QNetworkRequest(QUrl("http://localhost:19191/topicPost"));
        req1.setHeader(QNetworkRequest::ContentTypeHeader, "application/json");
    };

    QNetworkAccessManager* manager = nullptr;
    QNetworkRequest req1;

public slots:
    void post() {
        QByteArray dataToSend("{\"data\": \"Hello\"}");
        auto* reply = manager->post(req1, dataToSend);
    };


    void onfinish(QNetworkReply* rep) {
        if (rep->error() == QNetworkReply::NoError) {
            auto answer = rep->readAll();
            qDebug() << "Answer = " << answer;
        } else {
            qDebug() << "Error in request => " << rep->error();
        }
        rep->deleteLater();
        qDebug() << "reply delete!";
    };
};

class ThreadTmp: public QThread {
    Q_OBJECT
public:
    ThreadTmp() = delete;
    ThreadTmp(QObject* parent) {
        parent_ = parent;
        connect(this, SIGNAL(postRequest()), &pc, SLOT(post()));
    };

    QObject* parent_;
    PostClass pc;

signals:
    void postRequest();

protected:
    void run() override {
        while (1) {
            emit postRequest();
            QThread::msleep(500);
        }
    }
};


int main(int argc, char* argv[]) {
    QCoreApplication app (argc, argv);
    std::cout << "Hello, World!" << std::endl;

    ThreadTmp tmp(&app);

    tmp.start();

    return app.exec();
}

#include "main.moc"
